<?xml version="1.0" encoding="utf-8"?>

<collection>
  <lib_version>
      <=4.9.3
  </lib_version>

  <spec_type>
    <kind>
        common_env
    </kind>

    <init_code>
        allegro_init();
    </init_code>

    <final_code>
        allegro_exit();
    </final_code>

    <global_code>
        #include <system.h>
    </global_code>
  </spec_type>
</collection> 

<collection>
  <lib_version>
      >=4.9.4
  </lib_version>

  <spec_type>
    <kind>
        common_env
    </kind>

    <init_code>
        al_init();
    </init_code>

    <final_code>
        al_uninstall_system();
    </final_code>

    <global_code>
        #include <system_new.h>
    </global_code>
  </spec_type>
</collection>

<collection>
  <spec_type>
    <lib_version>
        >=4.9.7
    </lib_version>
    <kind>
        common_env
    </kind>

    <init_code>
        $[al_install_audio];
    </init_code>

    <final_code>
        $[al_uninstall_audio];
    </final_code>

    <global_code>
        #include <kcm_audio.h>
    </global_code>
  </spec_type>

  <spec_type>
    <lib_version>
        >=4.9.4
    </lib_version>
    <kind>
        common_env
    </kind>

    <init_code>
        $[al_install_joystick];
        $[al_install_keyboard];
        $[al_install_mouse];
    </init_code>

    <final_code>
        $[al_uninstall_mouse];
        $[al_uninstall_keyboard];
        $[al_uninstall_joystick];
    </final_code>

    <global_code>
        #include <joystick.h>
        #include <keyboard.h>
        #include <mouse.h>
    </global_code>
  </spec_type>

  <spec_type>
    <lib_version>
        4.9.3
    </lib_version>
    <kind>
        common_env
    </kind>

    <init_code>
        $[install_joystick];
        $[install_keyboard];
        $[install_mouse];
    </init_code>

    <final_code>
        $[remove_mouse];
        $[remove_keyboard];
        $[remove_joystick];
    </final_code>

    <global_code>
        #include <alcompat.h>
    </global_code>
  </spec_type>

  <spec_type>
    <lib_version>
        <=4.4.1.1
    </lib_version>
    <kind>
        common_env
    </kind>

    <init_code>
        $[install_joystick];
        $[install_keyboard];
        $[install_mouse];
    </init_code>

    <final_code>
        $[remove_mouse];
        $[remove_keyboard];
        $[remove_joystick];
    </final_code>

    <global_code>
        #include <joystick.h>
        #include <keyboard.h>
        #include <mouse.h>
    </global_code>
  </spec_type>

  <spec_type>
    <lib_version>
        >=4.9.3
    </lib_version>
    
    <kind>
        common_env
    </kind>

    <init_code>
        $[al_create_display:allegro_display];
        $[al_create_bitmap:allegro_bitmap];
        $[al_create_event_queue:allegro_event_queue];
    </init_code>

    <final_code>
        $[al_destroy_event_queue];
        $[al_destroy_bitmap];
        $[al_destroy_display];
    </final_code>

    <global_code>
        #include <allegro.h>
    </global_code>
    
    <associating>
      <except>
          al_create_display
          al_create_bitmap
          al_create_event_queue
          al_destroy_event_queue
          al_destroy_bitmap
          al_destroy_display
      </except>
    </associating>
  </spec_type>
  
  <spec_type>
    <lib_version>
        >=4.9.4
    </lib_version>
    
    <kind>
        common_env
    </kind>

    <init_code>
        $[al_create_mixer:allegro_mixer];
    </init_code>

    <final_code>
        $[al_destroy_mixer];
    </final_code>

    <global_code>
        #include <allegro.h>
    </global_code>
    
    <associating>
      <except>
          al_create_mixer
          al_destroy_mixer
      </except>
    </associating>
  </spec_type>

  <spec_type>
    <lib_version>
        >=4.9.7
    </lib_version>
    
    <kind>
        common_env
    </kind>

    <init_code>
        $[al_create_voice:allegro_voice];
    </init_code>

    <final_code>
        $[al_destroy_voice];
    </final_code>

    <global_code>
        #include <allegro.h>
    </global_code>
    
    <associating>
      <except>
          al_create_voice
          al_destroy_voice
      </except>
    </associating>
  </spec_type>
</collection>