<?xml version="1.0" encoding="utf-8"?>

<spec_type>
  <kind>
      common_env
  </kind>

  <init_code>
      g_type_init();
  </init_code>

  <libs>
      libgobject-2.0.so
  </libs>

  <global_code>
      #include <glib-object.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      Drawable
  </data_type>

  <global_code>
      #include <Xlib.h>
  </global_code>

  <value>
      XDefaultRootWindow($(Display*))
  </value>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      PangoFont*
  </data_type>

  <value>
      $[pango_x_load_font]
  </value>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "-monotype-arial-bold-r-normal--12-120-75-75-p-0-koi8-r"
  </value>

  <associating>
      <interfaces>
        pango_x_load_font
      </interfaces>
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      GCForeground|GCBackground
  </value>

  <associating>
      <interfaces>
        XCreateGC
      </interfaces>
      <links>
          param3
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      int
  </data_type>

  <value>
      AllocAll
  </value>

  <associating>
      <interfaces>
        XCreateColormap
      </interfaces>
      <links>
          param4
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      char const*
  </data_type>

  <value>
      "Arial bold 8"
  </value>

  <associating>
      <interfaces>
        pango_font_description_from_string
      </interfaces>
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      PangoRenderer*
  </data_type>

  <final_code>
      pango_renderer_activate($0);
  </final_code>

  <associating>
      <interfaces>
        pango_xft_renderer_new
      </interfaces>
      <links>
          retval
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      PangoColor
  </data_type>

  <value>
      {100, 200, 300}
  </value>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      PangoCairoFontMap*
  </data_type>

  <value>
      (PangoCairoFontMap*)$[pango_cairo_font_map_get_default]
  </value>
</spec_type>

<spec_type>
  <lib_version>
      >=1.15.2
  </lib_version>

  <kind>
      common_param
  </kind>

  <data_type>
      PangoLanguage*
  </data_type>

  <value>
      $[pango_language_get_default]
  </value>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      PangoFontDescription*
  </data_type>

  <value>
      $[pango_font_description_from_string]
  </value>
</spec_type>

<spec_type>
  <lib_version>
      <=1.15.1
  </lib_version>

  <kind>
      common_param
  </kind>

  <data_type>
      PangoLanguage*
  </data_type>

  <value>
      $[pango_language_from_string]
  </value>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GObject*
  </data_type>

  <value>
      g_object_new(G_TYPE_OBJECT, NULL)
  </value>

  <global_code>
      #include <glib.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      PangoFcFont*
  </data_type>

  <value>
      (PangoFcFont*)$[pango_x_load_font]
  </value>
</spec_type>
